//zakladni pozice kde zacina cisla8b.wav
#define		ZAKLADNIPOZICE	2949		

//definice delek zvuku pro cisla8b.wav
#define		_NULA		0
#define		_MINUS		1
#define		_1			2
#define	    _JEDNA		21
#define	    _20			22
#define		_JEDNO		30
#define		_DVE		31
#define		_STO		32
#define		_STA		33
#define		_SET		34
#define		_TISIC		35
#define		_TISICE		36
#define		_MILION		37
#define		_MILIONY	38
#define		_MILIONU	39

#define		_CELA   	40


#define		_PIKO   	41
#define		_NANO   	42
#define		_MILI   	43
#define		_KILO   	44
#define		_MEGA   	45
#define		_GIGA   	46

#define		_OHMU   	47
#define		_VOLT   	48
#define		_AMPER   	49
#define		_PASCAL   	50
#define		_METR   	51
#define		_GRAM   	52


//definice zacatku slov v textu cisla8b.wav ve strankach (po 264 byte)
static unsigned short __attribute__ ((progmem)) pozice[54] =
{0,13,31,50,62,75,96,110/**/,128,147,165,187,205,234,261,289,320,345,379,
413,444,478,499,521,540,567,595,623,658,691,725,746,762,778,791,806,
826,847,869,894,919,935,948,967,982,995,1011,1030,1046,1059,1080,1103,
1118,1135};

//je-li 1, budou obsluzne procedury cist cisla jako z Metexu
unsigned char metex;


unsigned short GetSlovoPos(unsigned char id)
{
    
	 return pgm_read_word(id+pozice);
}

void RekniSlovo(unsigned short id)
{
	unsigned char lformat=format;
	format=WAVE;
	if (!metex) {
		fprintf_P(seriak,PSTR("_Zvuk %d, od %d\n"),id,GetSlovoPos(id));
		fprintf_P(seriak,PSTR("_Prehravam od %d, delka %d\n"),ZAKLADNIPOZICE+GetSlovoPos(id),GetSlovoPos(id+1)-GetSlovoPos(id));
	};
	playback(ZAKLADNIPOZICE+GetSlovoPos(id),GetSlovoPos(id+1)-GetSlovoPos(id)-1);
	format=lformat;
}

void RekniStovky(unsigned short cislo)
{
	//rekne cislo v rozsahu 0 - 999
	//nerika nulu
	if (cislo>=100) {
	 //sta:
	 //sto, dve/tri/ctyri sta, pet/sest/sedm/osm/devet set
	 unsigned char pocetstovek=(unsigned char)((unsigned short)cislo/100);
	 if (pocetstovek>=2) {
	  //rekni pocet stovek
	  RekniSlovo(_1+pocetstovek-1);
	 }
	 //vysklonuj sta
	 if (pocetstovek==1) {
	  RekniSlovo(_STO);
	 }
	 if (pocetstovek>1&&pocetstovek<5) {
	  RekniSlovo(_STA);
	 }
	 if (pocetstovek>4) {
	  RekniSlovo(_SET);
	 }	 
	 cislo=cislo%100;
	}
	//zbyva hodnota do 99
	//musime rict desitky zvlast?
	if (cislo>=20) {
	 //rekneme rad desitek
	 RekniSlovo(_20+cislo/10-2);
	 cislo=cislo%10;
	}
	//ted muzeme rict primo cislo, pokud to teda neni nula
	if (cislo!=0) {
	 RekniSlovo(_1-1+cislo);
	}	
}

void RekniCislo(unsigned long cislo)
{
	unsigned short rad;
	if (cislo==0) {
	 RekniSlovo(_NULA);
	} else {
		if (cislo>=1000000) {
		 //rikej rad milionu
		 rad=cislo/1000000;
		 RekniStovky(rad);
		 if (rad==1) {
		  RekniSlovo(_MILION);
		 } else
		 if (rad>1&&rad<5) {
		  RekniSlovo(_MILIONY);
		 } else {
		  RekniSlovo(_MILIONU);
		 }
		 
		 cislo=cislo%1000000;
		}
		if (cislo>1000) {
		 //rikej rad tisicu	
		 rad=cislo/1000;
		 RekniStovky(rad);
		 if (rad>1&&rad<5) {
		  RekniSlovo(_TISICE);
		 } else {
		  RekniSlovo(_TISIC);
		 }
		 cislo=cislo%1000;
		}
		//rikej zbytek cisla
		RekniStovky(cislo);
	}	
}

