unit term_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AfDataDispatcher, AfComPort, StdCtrls, ComCtrls, Spin, ExtCtrls,
  CheckLst,math, AfPortControls;

type
  TfrmMain = class(TForm)
    com: TAfComPort;
    edSend: TEdit;
    btnSend: TButton;
    OpenDialog: TOpenDialog;
    lblInfo: TLabel;
    btnEsc: TButton;
    pgc: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    memo: TListBox;
    Label5: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Label7: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    Button3: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Edit3: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Edit4: TEdit;
    Button8: TButton;
    Button9: TButton;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Bevel2: TBevel;
    TabSheet7: TTabSheet;
    Button10: TButton;
    Button11: TButton;
    Bevel1: TBevel;
    Label17: TLabel;
    Bevel3: TBevel;
    Label18: TLabel;
    Edit5: TEdit;
    Label19: TLabel;
    Edit6: TEdit;
    Label20: TLabel;
    Button12: TButton;
    Label21: TLabel;
    Edit7: TEdit;
    Button13: TButton;
    Label22: TLabel;
    Label23: TLabel;
    clbSet: TCheckListBox;
    Button14: TButton;
    clbLED: TCheckListBox;
    Button15: TButton;
    Label24: TLabel;
    clbRoz: TCheckListBox;
    Button16: TButton;
    Label25: TLabel;
    Label26: TLabel;
    Edit8: TEdit;
    Button17: TButton;
    Button18: TButton;
    Label27: TLabel;
    GroupBox1: TGroupBox;
    AfPortComboBox1: TAfPortComboBox;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    procedure btnSendClick(Sender: TObject);
    procedure comDataRecived(Sender: TObject; Count: Integer);
    procedure edSendKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnEscClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure btnrecord(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure comPortOpen(Sender: TObject);
    procedure comPortClose(Sender: TObject);
    procedure comLineError(Sender: TObject; Errors: Cardinal);
    procedure Button21Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Voicecalc(id:integer);
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnSendClick(Sender: TObject);
begin
 com.WriteString(edSend.Text+#13);
 btnEsc.Enabled:=true;
end;

var speaks:boolean;

procedure TfrmMain.Voicecalc(id:integer);

begin

end;

procedure TfrmMain.comDataRecived(Sender: TObject; Count: Integer);
var ch:char;
begin
 while com.InBufUsed>0 do begin
  ch:=com.readchar;
  if ch=#13 then begin
     if pos('OK',memo.items[memo.items.count-1])=1 then btnEsc.enabled:=false;
     memo.Items.Add('');
  end;
  if not (ch in [#10,#13]) then
   memo.items[memo.items.count-1]:=memo.items[memo.items.count-1]+ch;
   memo.ItemIndex:=memo.Items.Count-1;
  end;

end;

procedure TfrmMain.edSendKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then btnSend.Click;
end;

function ToChar(inp:byte):char;
begin
 if inp<10 then ToChar:=chr(ord('0')+inp) else ToChar:=chr(ord('A')+inp-10);
end;

procedure TfrmMain.Button1Click(Sender: TObject);
var f:file of byte;i:integer; b:byte;
begin
 if opendialog.execute then begin
  showmessage('Neprerusujte funkci ani neobsluhujte ovladaci prvky programu, dokud se nezobrazi "Hotovo." na stavovem radku.');
  assignfile(f,OpenDialog.FileName);
  reset(f);
  if CheckBox1.Checked then for i:=1 to 44 do read(f,b);
  i:=0;
  btnEsc.Enabled:=false;
  while (not eof(f)) and (not Application.Terminated) do begin
   inc(i);
   if i mod 1024=0 then begin
    lblInfo.Caption:='Odeslno '+inttostr(i div 1024)+' KB';
    Application.processmessages;
   end;
   read(f,b);
   com.writechar(ToChar(b shr 4));
   com.writechar(ToChar(b and 15));
   while com.OutBufFree<com.OutBufSize-100 do ;
  end;
  closefile(f);
  lblInfo.Caption:='Hotovo.';
 end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var i:integer;
begin
// memo.items.add('Vysilaci buffer: '+inttostr(com.OutBufSize));
for i:=0 to clbSet.Items.Count-1 do clbset.Checked[i]:=true;
end;

procedure TfrmMain.btnEscClick(Sender: TObject);
begin
 com.WriteChar(#27);
end;

procedure TfrmMain.Button6Click(Sender: TObject);
begin
 edSend.Text:='FW';
 btnSend.Click;
end;

procedure TfrmMain.Button5Click(Sender: TObject);
begin
 edSend.Text:='FF';
 btnSend.Click;
end;

procedure TfrmMain.Button7Click(Sender: TObject);
begin
 edSend.Text:='FA';
 btnSend.Click;
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
 edSend.Text:='FP';
 btnSend.Click;

end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
 edSend.Text:='WP '+edit1.Text+' '+edit2.text;
 btnSend.Click;
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
 edSend.Text:='VS '+inttostr(spinedit1.Value)+' '+inttostr(spinedit2.Value);
 btnSend.Click;

end;

procedure TfrmMain.btnrecord(Sender: TObject);
begin
 edSend.Text:='WR '+edit3.Text+' '+edit4.text;
 btnSend.Click;
end;

procedure TfrmMain.Button9Click(Sender: TObject);
begin
 edSend.Text:='WL '+edit3.Text+' '+edit4.text;
 btnSend.Click;
 showmessage('Nyn zvolte funkci Poli soubor z karty Nahrej z WAV');
end;

procedure TfrmMain.Button10Click(Sender: TObject);
begin
 edSend.Text:='IE';
 btnSend.Click;
end;

procedure TfrmMain.Button11Click(Sender: TObject);
begin
 edSend.Text:='II';
 btnSend.Click;

end;

procedure TfrmMain.Button12Click(Sender: TObject);
begin
 edSend.Text:='WE '+edit6.Text+' '+edit5.text;
 btnSend.Click;

end;

procedure TfrmMain.Button13Click(Sender: TObject);
begin
 edSend.Text:='NF '+edit7.Text;
 btnSend.Click;
end;

procedure TfrmMain.Button14Click(Sender: TObject);
var i,j:integer;
begin
 i:=0;
 for j:=0 to clbset.items.Count-1 do if clbset.Checked[j] then
  i:=i+round(intpower(2,j));
 edSend.Text:='CS '+inttostr(i);
 btnSend.Click;
end;

procedure TfrmMain.Button15Click(Sender: TObject);
var i,j:integer;
begin
 i:=0;
 for j:=0 to clbled.items.Count-1 do if clbled.Checked[j] then
  i:=i+round(intpower(2,j));
 edSend.Text:='CL '+inttostr(i);
 btnSend.Click;
end;

procedure TfrmMain.Button16Click(Sender: TObject);
begin
 edSend.Text:='RW '+edit8.Text;
 btnSend.Click;
end;

procedure TfrmMain.Button17Click(Sender: TObject);
begin
 edSend.Text:='RR';
 btnSend.Click;
end;

procedure TfrmMain.Button18Click(Sender: TObject);
var j:integer;
begin
 edSend.Text:='RS ';
 for j:=0 to clbRoz.items.Count-1 do if clbRoz.Checked[j] then
  edSend.Text:=edSend.Text+'1' else
  edSend.Text:=edSend.Text+'0';
 btnSend.Click;
end;

procedure TfrmMain.Button19Click(Sender: TObject);
begin
 com.Open;
end;

procedure TfrmMain.Button20Click(Sender: TObject);
begin
 com.Close;
 pgc.Enabled:=false;
end;

procedure TfrmMain.comPortOpen(Sender: TObject);
begin
 pgc.Enabled:=true;
 showmessage('Pripojen.');
 button19.enabled:=false;
 button21.enabled:=false;
 button20.enabled:=true;
end;

procedure TfrmMain.comPortClose(Sender: TObject);
begin
 showmessage('Odpojen.');
 button20.enabled:=false;
 button19.enabled:=true;
 button21.enabled:=true; 
end;

procedure TfrmMain.comLineError(Sender: TObject; Errors: Cardinal);
begin
 showmessage('Chyba pri prenosu dat: '+inttostr(errors));

end;

procedure TfrmMain.Button21Click(Sender: TObject);
begin
 com.ExecuteConfigDialog;
end;

end.
